' Windows Routines
' ================
'  By Neil Richardson
'  ==================
' You may use these freely to make your own interface for your software
' Known bugs: If you overlap some Windows, I keeps on changing between
' them if you hold down the mouse button where they overlap. Try and fix
' it for me.
' At the moment it is a simple VBDOS emulation, but will only display 1
' window, it is completly based on Graphics modes. Default is 640x480x8.
' This will create windows easily.
' You can look through this and remove the examples once you've cracked
' it. It shouldn't take long. I couldn't be botheres to put a full
' Explantion in but, I will tell you about the Object Type:
'
' Caption - The Caption, Window title, Button Text. Max 20 Characters.
' X - X Position
' Y - Y Position
' W - Width
' H - Height
' BgColor - Background Colour
' CapColor - Caption Colour
' Value - Is it activated?
'
'
'
' ============================================================================
' Declares and Includes
' ============================================================================

' Object Commands
DECLARE SUB Buttonx (index AS INTEGER)
DECLARE SUB Windowx (index AS INTEGER)

' Object Handlers
DECLARE SUB Checkwin ()
DECLARE SUB Windowcode (index AS INTEGER)
DECLARE SUB Buttoncode (index AS INTEGER)
DECLARE SUB Usercode ()

' Mouse Routines
DECLARE SUB Getmouse ()

' Window loaders & examples
DECLARE SUB frmAbout ()
DECLARE SUB btnOk ()


'$INCLUDE: 'future.bi'

' ============================================================================
' Types
' ============================================================================

TYPE Object
        Caption AS STRING * 20
        X AS INTEGER
        Y AS INTEGER
        W AS INTEGER
        H AS INTEGER
        Bgcolor AS LONG
        CapColor AS LONG
        Value AS INTEGER
        Visible AS INTEGER
        Winind AS INTEGER  ' Non-Window case only - Window object is in
        Clicked AS INTEGER
END TYPE

' ============================================================================
' Dimensions and Constants
' ============================================================================

DIM SHARED Hwnd(15) AS Object ' Window
DIM SHARED Hbtn(15) AS Object ' Button

DIM SHARED MX, MY, MB
DIM i AS INTEGER

CONST True = -1
CONST False = 0

' ============================================================================
' Screen Setup
' ============================================================================

Set640x480 8
Future.Fillbox 0, 0, 640, 480, 1

' ============================================================================
' Mouse setup
' ============================================================================

future.mouseon

' ============================================================================
' Set the Objects here, There are 3 examples, You can use Math
' ============================================================================

Hwnd(0).Caption = "About"
Hwnd(0).X = 240
Hwnd(0).Y = 200
Hwnd(0).W = 160
Hwnd(0).H = 100
Hwnd(0).Bgcolor = 7
Hwnd(0).CapColor = 14
Hwnd(0).Value = False
Hwnd(0).Visible = True

Hbtn(0).Caption = "Ok"
Hbtn(0).X = 18
Hbtn(0).Y = 55
Hbtn(0).W = 50
Hbtn(0).H = 18
Hbtn(0).Bgcolor = 7
Hbtn(0).CapColor = 0
Hbtn(0).Value = False
Hbtn(0).Visible = False
Hbtn(0).Winind = 0
Hbtn(0).Clicked = False

' Center the X pos of the button
Hbtn(0).X = ((Hwnd(0).W - Hbtn(0).W) / 2) - 4



' ============================================================================
' Start your own code here
' ============================================================================

frmAbout                      ' Open About window

DO
Getmouse                   ' Get Mouse Cords
FOR i = 0 TO 15
Windowcode i
Buttoncode i
NEXT i
Usercode
LOOP UNTIL MB = 2 OR Hbtn(0).Clicked

Resetscreen
END

SUB btnOk
DIM X1
DIM X2
DIM Y1
DIM Y2

X1 = Hbtn(0).X + Hwnd(0).X + 4
X2 = Hbtn(0).X + Hbtn(0).W + Hwnd(0).X + 4
                                            
Y1 = Hbtn(0).Y + Hwnd(0).Y + 20
Y2 = Hbtn(0).Y + Hbtn(0).H + Hwnd(0).Y + 20

IF MX > X1 AND MX < X2 AND MY > Y1 AND MY < Y2 AND MB = 1 THEN
    Hbtn(0).Clicked = True
    Hbtn(0).Value = True
    Buttonx 0
    DO
    Getmouse
    IF NOT (MX > X1 AND MX < X2 AND MY > Y1 AND MY < Y2) THEN
        Hbtn(0).Clicked = False
        Hbtn(0).Value = False
        Buttonx 0
        EXIT SUB
    END IF

    LOOP UNTIL MB = 0
    Hbtn(0).Value = False
    Buttonx 0


END IF



END SUB

SUB Buttoncode (index AS INTEGER)
' You insert your Code and Calls in here for your Button index
' This is the Main Button Sub
SELECT CASE index
    CASE 0: CALL btnOk
    CASE ELSE
END SELECT

END SUB

SUB Buttonx (index AS INTEGER)
' Turn mouse off before drawing
future.mouseoff

' Tells event handler that button is open
Hbtn(index).Visible = True

' Local Dimensions
DIM Y1 AS INTEGER
DIM W1 AS INTEGER
DIM TW AS INTEGER
DIM H1 AS INTEGER
DIM BG AS LONG
DIM Col AS LONG
DIM Title AS STRING
DIM Active AS INTEGER
DIM Win AS INTEGER

' Set the Variables
X1 = Hbtn(index).X
Y1 = Hbtn(index).Y
W1 = Hbtn(index).W
H1 = Hbtn(index).H
BG = Hbtn(index).Bgcolor
Col = Hbtn(index).CapColor
Title = Hbtn(index).Caption
Active = Hbtn(index).Value
Win = Hbtn(index).Winind

X1 = X1 + Hwnd(Win).X + 4
Y1 = Y1 + Hwnd(Win).Y + 20

' Get rid of spaces at end of caption and get text width in pixels
FOR i = 1 TO 20
IF RIGHT$(Title, i) <> STRING$(i, " ") THEN Title = LEFT$(Title, 20 - i + 1): EXIT FOR
NEXT i

TW = LEN(Title) * 8
' Check Value
' Draw Normal or Invert button

SELECT CASE Active
    CASE False
        Future.Fillbox X1, Y1, X1 + W1, Y1 + H1, BG

        Future.Line X1, Y1, X1 + W1, Y1, 15, -1
        Future.Line X1, Y1 - 1, X1 + W1, Y1 - 1, 15, -1

        Future.Line X1, Y1 + H1, X1 + W1, Y1 + H1, 0, -1
        Future.Line X1, Y1 + H1 + 1, X1 + W1, Y1 + H1 + 1, 0, -1

        Future.Line X1, Y1, X1, Y1 + H1, 15, -1
        Future.Line X1 - 1, Y1, X1 - 1, Y1 + H1, 15, -1
       
        Future.Line X1 + W1, Y1, X1 + W1, Y1 + H1, 0, -1
        Future.Line X1 + W1 + 1, Y1, X1 + W1 + 1, Y1 + H1, 0, -1

        Future.Print X1 + ((W1 - TW) / 2), Y1 + 1, Title, Col, BG

    CASE True
        Future.Fillbox X1, Y1, X1 + W1, Y1 + H1, BG

        Future.Line X1, Y1, X1 + W1, Y1, 0, -1
        Future.Line X1, Y1 - 1, X1 + W1, Y1 - 1, 0, -1

        Future.Line X1, Y1 + H1, X1 + W1, Y1 + H1, 15, -1
        Future.Line X1, Y1 + H1 + 1, X1 + W1, Y1 + H1 + 1, 15, -1

        Future.Line X1, Y1, X1, Y1 + H1, 0, -1
        Future.Line X1 - 1, Y1, X1 - 1, Y1 + H1, 0, -1
      
        Future.Line X1 + W1, Y1, X1 + W1, Y1 + H1, 15, -1
        Future.Line X1 + W1 + 1, Y1, X1 + W1 + 1, Y1 + H1, 15, -1

        Future.Print X1 + ((W1 - TW) / 2) + 1, Y1 + 2, Title, Col, BG

END SELECT

future.mouseon
END SUB

SUB Checkbtn

END SUB

SUB Checkwin
' Local Variables
DIM i AS INTEGER

' Check to see which Window is active (Value = True)

FOR i = 0 TO 15
    IF Hwnd(i).Value THEN EXIT FOR
NEXT i

' Call the Windowcode sub, with your modified code
Windowcode i
END SUB

SUB frmAbout
future.mouseoff
' Open the Window
Windowx 0
' Open any Controls
Buttonx 0
' Any other functions
Future.Print Hwnd(0).X + 18, Hwnd(0).Y + 25, "Windows Library", 0, 7
Future.Print Hwnd(0).X + 6, Hwnd(0).Y + 42, "By Neil Richardson", 0, 7
future.mouseon
END SUB

SUB Getmouse
Future.UpdateMouse
MX = Future.MouseX%
MY = Future.MouseY%
MB = Future.MouseB%

END SUB

' This sub has all you user code, like calls to TSRs or
' change graphics on the screen. It will be used in windos
' for displaying the time on the Option Bar
SUB Usercode

END SUB

SUB Windowcode (index AS INTEGER)
' You insert your Code and Calls in here for your Window index
' This is the Main window sub
SELECT CASE index
    CASE ELSE
END SELECT

END SUB

SUB Windowx (index AS INTEGER)
' Turn mouse off before drawing
future.mouseoff

' Tells event handler that window is open
Hwnd(index).Visible = True

' Local Variables

DIM X1 AS INTEGER
DIM Y1 AS INTEGER
DIM W1 AS INTEGER
DIM H1 AS INTEGER
DIM BG AS LONG
DIM Col AS LONG
DIM Title AS STRING

' Set the Variables

X1 = Hwnd(index).X
Y1 = Hwnd(index).Y
W1 = Hwnd(index).W
H1 = Hwnd(index).H
BG = Hwnd(index).Bgcolor
Col = Hwnd(index).CapColor
Title = Hwnd(index).Caption

' Get rid of spaces at end of caption
FOR i = 1 TO 20
IF RIGHT$(Title, i) <> STRING$(i, " ") THEN Title = LEFT$(Title, 20 - i + 1): EXIT FOR
NEXT i


' Error Checking

IF W1 < 50 THEN W1 = 50
IF H1 < 19 THEN H1 = 19

' Draw Window

Future.Fillbox X1, Y1, X1 + W1, Y1 + H1, BG
Future.Fillbox X1 + 1, Y1 + 1, X1 + (W1 - 1), Y1 + 17, 1

Future.Line X1, Y1 + 18, X1 + W1, Y1 + 18, 0, -1
Future.Line X1, Y1 + 19, X1 + W1, Y1 + 19, 0, -1

Future.Line X1, Y1, X1 + W1, Y1, 15, -1
Future.Line X1, Y1 - 1, X1 + W1, Y1 - 1, 15, -1

Future.Line X1, Y1, X1, Y1 + H1, 15, -1
Future.Line X1 - 1, Y1, X1 - 1, Y1 + H1, 15, -1

Future.Line X1, Y1 + H1, X1 + W1, Y1 + H1, 0, -1
Future.Line X1, Y1 + H1 + 1, X1 + W1, Y1 + H1 + 1, 0, -1

Future.Line X1 + W1, Y1, X1 + W1, Y1 + H1, 0, -1
Future.Line X1 + W1 + 1, Y1, X1 + W1 + 1, Y1 + H1, 0, -1

Future.Print X1 + 3, Y1 + 2, Title, Col, 1

' Turn mouse on after drawing
future.mouseon


END SUB

